namespace Parsing.Data;

public static class DataManipulationHelpers
{
    public static TType ReduceData<TType>(this List<TType> data, Func<TType, TType, TType> reducer)
    {
        if (data.Count < 2)
        {
            return data[0];
        }
        TType result = data[0];
        for (int i = 1; i < data.Count; i++)
        {
            result = reducer(result, data[i]);
        }
        return result;
    }

    public static TType ReduceData<TType>(this List<TType> data, Func<List<TType>, TType> reducer)
    {
        return reducer(data);
    }
}